Subject: [Rats] YANG fills a gap that is similar to what OpenAPI/RAML fills?

From: "Smith, Ned" <[email-masked]>
Date: Wed, 13 Nov 2019 00:30:37 +0000

Yes, they are rough analogs. RAML is a schema (metadata) that describes payloads for RESTful requests (get, put, push, delete) and responses. It is roughly CRUD semantics. The payload is where the complexity can hide. Payloads can be expressed using a data model language such as JSON. RAML and OpenAPI organizations merged recently. I presume that means RAML and OpenAPI will become one - OpenAPI-next.

In the context of RATS, Evidence, Attestation Results (and maybe Reference Values?) could be the payloads to a RAML/OpenAPI description of a RESTful interaction. The RATS interaction models (e.g. Passport) also called "message flow" could be realized in a RESTful protocol. 

Both data (payload) and protocol can be modeled using IM/DM expressions before being realized in a 'wire format'. 

I haven't seen CDDL used to model protocols. But I believe YANG can be used for that purpose. Both can be used to model data (payloads or data at rest objects). 

On 11/12/19, 0:28 AM, "RATS on behalf of Michael Richardson" <[email-masked] on behalf of [email-masked]> wrote:

    >
    > You’re saying YANG fills a gap that is similar to what OpenAPI/RAML fills?
    >
    
    I don't know what those things are.
    I might say it was similar to CORBA, but I'd be dating myself and I
    never really knew CORBA very well.